/*
 * Copyright 2020 ZUP IT SERVICOS EM TECNOLOGIA E INOVACAO SA
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package br.com.zup.beagle.automatedTests.cucumber.elements

const val MAIN_HEADER = "Automated Tests"

//Button Screen
const val BUTTON_SCREEN_HEADER = "Beagle Button"
const val BUTTON_DEFAULT_TEXT = "Button"
const val BUTTON_WITH_STYLE_TEXT = "Button with style"
const val BUTTON_WITH_APPEARANCE_TEXT = "Button with Appearance"
const val ACTION_CLICK_HEADER = "Action Click"
const val ACTION_CLICK_TEXT = "You clicked right"

//Text Screen
const val TEXT_SCREEN_HEADER = "TextScreen"
const val TEXT_DEFAULT = "TextValue"
const val TEXT_VIA_EXPRESSION = "TextValueViaExpression"
const val TEXT_WITH_TEXT_COLOR = "TextWithColor"
const val TEXT_WITH_TEXT_COLOR_VIA_EXPRESSION = "TextWithColorViaExpression"
const val TEXT_WITH_ALIGNMENT_LEFT = "TextAlignedLeft"
const val TEXT_WITH_ALIGNMENT_CENTER = "TextAlignedCenter"
const val TEXT_WITH_ALIGNMENT_RIGHT = "TextAlignedRight"
const val TEXT_WITH_ALIGNMENT_LEFT_VIA_EXPRESSION = "TextAlignedLeftViaExpression"
const val TEXT_WITH_ALIGNMENT_CENTER_VIA_EXPRESSION = "TextAlignedCenterViaExpression"
const val TEXT_WITH_ALIGNMENT_RIGHT_VIA_EXPRESSION = "TextAlignedRightViaExpression"

//Image Screen
const val IMAGE_SCREEN_HEADER = "Beagle Image"
const val IMAGE_TEXT_1 = "Image"
const val IMAGE_TEXT_2 = "Image with contentMode = FIT_XY"
const val IMAGE_TEXT_3 = "Image with contentMode = FIT_CENTER"
const val IMAGE_TEXT_4 = "Image with contentMode = CENTER_CROP"
const val IMAGE_TEXT_5 = "Image with contentMode = CENTER"

//TabView Screen
const val TABVIEW_SCREEN_HEADER = "Beagle Tab View"
const val TAB_1 = "TAB 1"
const val TAB_1_TEXT = "Welcome to Tab 1"
const val TAB_1_TEXT_2 = "This is Tab1's second text"
const val TAB_2 = "TAB 2"
const val TAB_2_TEXT = "Welcome to Tab 2"
const val TAB_2_TEXT_2 = "This is Tab2's second text"
const val TAB_3 = "TAB 3"
const val TAB_3_TEXT = "Welcome to Tab 3"
const val TAB_3_TEXT_2 = "This is Tab3's second text"
const val TAB_4 = "TAB 4"
const val TAB_4_TEXT = "Welcome to Tab 4"
const val TAB_4_TEXT_2 = "This is Tab4's second text"

//PageView Screen
const val PAGEVIEW_SCREEN_HEADER = "Beagle PageView"
const val PAGE_1_TEXT = "Page 1"
const val PAGE_2_TEXT = "Page 2"
const val PAGE_3_TEXT = "Page 3"

//ListView Screen
const val LISTVIEW_SCREEN_HEADER = "Beagle ListView"
const val STATIC_LISTVIEW_TEXT_1 = "Static VERTICAL ListView"
const val STATIC_LISTVIEW_TEXT_2 = "Static HORIZONTAL ListView"
const val DYNAMIC_LISTVIEW_TEXT_1 = "Dynamic VERTICAL ListView"
const val DYNAMIC_LISTVIEW_TEXT_2 = "Dynamic HORIZONTAL ListView"

//Touchable Screen
const val TOUCHABLE_SCREEN_HEADER = "Beagle Touchable"
const val TOUCHABLE_TEXT_1 = "Text with Touchable"
const val TOUCHABLE_TEXT_2 = "Click here!"
const val TOUCHABLE_TEXT_3 = "Image with Touchable"
const val TOUCHABLE_TEXT_4 = "NetworkImage with Touchable"